<template>
  <div class="voucher-air-drop">
    <p class="title-component">
      {{ $t('bounty.bug_report.title', {tokens: settings.bug_report.value}) }}
    </p>

    <div class="article-group">
      <div class="article-item">
        <div class="article__content">
          <div class="article__text" >
            <span>{{ $t('bounty.bug_report.text_title') }}</span>
          </div>
          <div class="article-input-wrapper">
            <div class="article__input-link">
              <input type="text" @focus="resetError"
                v-validate="'required'"
                data-vv-validate-on="none"
                name="title"
                class="article__url"
                v-model="title"
                @keyup.enter="create()"
              >
              <br>
              <span class="error show" v-if="errors.has('title')">{{ errors.first('title') }}</span>
            </div>
          </div>
          <div class="article__text" >
            <span>{{ $t('bounty.bug_report.text_description') }}</span>
          </div>
          <div class="article-input-wrapper">
            <div class="article__input-link">
              <textarea type="text" @focus="resetError"
                v-validate="'required'"
                data-vv-validate-on="none"
                name="description"
                class="article__url_textarea"
                v-model="description"
              ></textarea>
              <br>
              <span class="error show" v-if="errors.has('description')">{{ errors.first('description') }}</span>
            </div>
          </div>
          <div class="btn-area">
            <button type="button" class="btn-submit" @click="create()">{{ $t('bounty.bug_report.btn_submit') }}</button>
          </div>
          <div class="article-input-wrapper">
            <div class="article__link-group" v-for="item in bugBounties">
              <div class="article__link-item">
                <div class="link">
                  {{ item.title }}
                </div>
                <div class="bounty">
                  {{ (item.status === 'approved' ? item.heta_tokens : 0) | formatCurrencyAmount('heta', '0') }}
                </div>

                <div :class="`status ${item.status}`">
                  {{ item.status | upperFirst }}
                </div>
              </div>
            </div>
          </div>
          <div class="ctu-total">
            <p class="title">{{ $t('common.heta_tokens') }}</p>
            <div class="number">{{ total | formatCurrencyAmount('heta', '0') }}</div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { mapState } from 'vuex';
import BigNumber from 'bignumber.js';

import rf from '../../../common/requests/RequestFactory';

export default {
  props: {
    settings: {
      type: Object,
      default: null,
      required: true,
    }
  },
  data() {
    return {
      title: '',
      description: '',
      bugBounties: [],
      total: 0,
    };
  },
  methods: {
    resetError () {
      this.errors.clear();
    },
    create () {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          const params = {
            user_id: this.user.id,
            description: this.description,
            title: this.title,
          };
          rf.getRequest('BugBountyRequest').create(params)
            .then(() => {
              this.title = '';
              this.description = '';
              this.getAllBugBounties();
            })
            .catch((error) => {
              const errors = error.errors;
              this.errors.clear();
              Object.keys(errors).forEach((key) => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
            });
        });
    },
    async getAllBugBounties () {
      const result = await rf.getRequest('BugBountyRequest').getAllBugBounties({
        sortField: 'id',
        sortDirection: 'desc',
      });
      this.bugBounties = [...result.data];
      this.total = result.data
                    .filter(item => item.status === 'approved')
                    .reduce((sum, item) => {
                      return BigNumber(sum).plus(item.heta_tokens);
                    }, 0);
    }
  },
  computed: {
    ...mapState([
      'user',
    ]),
  },
  created () {
    this.getAllBugBounties();
  },
};
</script>
<style scoped lang="scss">
  .voucher-air-drop {
    padding: 30px 0 30px;
  }

  .title-component {
    margin-bottom: 9px;
  }

  .article-item {
    margin-bottom: 0;
    .article__title {
      font-size: 1rem;
      margin-bottom: 10px;
    }
    .article__content {
      color: #858585;
      font-size: 0.75rem;
      margin-bottom: 0;
    }

    .article__input-link {
      font-size: 0;
      position: relative;
      margin-bottom: 0;
    }
    .article__url {
      vertical-align: middle;
      padding: 6px 10px;
      width: calc(100% - 90px);
      font-size: 13px;
      color: #222c3c;
      border: 1px solid #d2d2d2;
      background-color: #fff;
      border-radius: 74px;

      &::placeholder {
        font-size: 13px;
      }
    }
    .article__url_textarea {
      width: calc(100% - 90px);
      font-size: 13px;
      color: #222c3c;
      border: 1px solid #d2d2d2;
      background-color: #fff;
      border-radius: 10px;
      height: 120px;
      resize: none;
      outline: none;
    }
    .article__text {
      font-size: 13px;
      color: #222c3c;
      letter-spacing: 0.5px;
      margin-bottom: 6px;
      margin-top: 14px;
    }
    .article__description {
      font-size: 0.875rem;
      margin-bottom: 27px;
    }
    .article__link-group {
      .article__link-item {
        font-size: 0;
        margin-bottom: 10px;
        width: calc(100% - 90px);
        .bounty,
        .link,
        .status {
          display: inline-block;
          width: 100px;
          padding: 5px 10px;
          margin-right: 10px;
          font-size: 13px;
          background-color: #ebebeb;
          vertical-align: middle;
          color: #222c3c;
          border-radius: 74px;
          border: 1px solid #d8dbe7;
        }
        .link {
          color: #222c3c;
          width: calc(100% - 220px);
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
          text-align: center;
        }

        .status {
          margin-right: 0;
          text-align: center;
          font-weight: bold;
          &.pending {
            color: #fcb202;
          }
          &.rejected {
            color: #d0021b;
          }
          &.approved {
            color: #4caf50;
          }
        }
      }
    }
  }
  .btn-submit {
    width: 160px;
    height: 40px;
    border-radius: 30px;
    background-color: #fa7300;
    margin: 20px 0 40px;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 2.5;
    letter-spacing: 0.5px;
    text-align: center;
    color: #ffffff;
    text-transform: uppercase;
    outline: none;
    border: none;
  }
  .ctu-total {
    font-size: 0;
    padding: 5px 0px 30px;
    margin-top: 35px;
    .title {
      text-align: right;
      margin-right: 49px !important;
    }

  }
  .error {
    color: red;
    display: inline-block;
    margin-bottom: 5px;
    font-size: 12px;
    padding-left: 10px;
    display: none;
    transition: all 0.3s ease-in-out;
    padding: 0 !important;
    position: absolute;
    bottom: -20px;
    &.show {
      display: block;
    }
  }

  .article__link-group {
    width: 100% !important;
  }
</style>
